package example.filesystem.backend;

import java.util.List;
import java.util.ArrayList;


/**
 * This is a mock filesystem to act as the backend for the example FileSystemService
 *
 * @author Sal Campana
 */
public class UnixFileSystem implements FileSystem
{

    private String m_mountPoint="/usr";
    private String m_type = "vxfs";
    private int m_backupFrequency=0;
    private int m_fsckPassNumber=2;
    private List m_options = new ArrayList();
    private String m_comment="user files";
    private String m_deviceSpecialFile = "/dev/vg00/lvol7";
    private boolean m_isMounted = true;

    public UnixFileSystem(String devicePath)
    {
        m_deviceSpecialFile = devicePath;
        m_options.add("delaylog");
        m_options.add("quota");
    }

    public String getDeviceSpecialFile()
    {
        return m_deviceSpecialFile;
    }
    public String getMountPoint()
    {
        return m_mountPoint;
    }
    public void setMountPoint(String mountDir)
    {
        m_mountPoint=mountDir;
    }
    public String getType()
    {
        return m_type;
    }

    public int getBackupFrequency()
    {
        return m_backupFrequency;
    }

    public void setBackupFrequency(int backupFrequency)
    {
        m_backupFrequency = backupFrequency;
    }

    public List getOptions()
    {
        return m_options;
    }

    public void setOptions(List options)
    {
        m_options = options;
    }

    public String getComment()
    {
        return m_comment;
    }

    public void setComment(String comment)
    {
        m_comment = comment;
    }

    public int getFsckPassNumber()
    {
        return m_fsckPassNumber;
    }

    public void setFsckPassNumber(int fsckPassNumber)
    {
        m_fsckPassNumber = fsckPassNumber;
    }

    public void mount() throws Exception
    {
        m_isMounted = true;
    }

    public void unmount() throws Exception
    {
        m_isMounted = false;
    }

    public boolean isMounted()
    {
        return m_isMounted;
    }
}
