package org.apache.ws.resource.example.filesystem;

import org.apache.ws.addressing.EndpointReference;
import org.apache.ws.resource.NamespaceVersionHolder;

/**
 * **** WARNING: This file will be overwritten during generation ****
 * <p/>
 * An abstract Filesystem WS-Resource.
 * <p/>
 * NOTE: This class is generated and is NOT meant to be modified.
 */
public abstract class AbstractFilesystemResource
        implements org.apache.ws.resource.lifetime.ScheduledResourceTerminationResource,
        org.apache.ws.resource.PropertiesResource
{

    /**
     * A NamespaceVerionHolder which maintains the XML namespaces for all specifications supported by this resource.
     */
    private static final org.apache.ws.resource.properties.v2004_06.impl.NamespaceVersionHolderImpl SPEC_NAMESPACE_SET = new org.apache.ws.resource.properties.v2004_06.impl.NamespaceVersionHolderImpl();

    /**
     * The unique identifier for this resource.
     */
    private String m_id;

    /**
     * The EndpointReference (EPR) for this resource.
     */
    protected EndpointReference m_endpointReference;

    /**
     * The set of properties associated with this resource.
     */
    protected org.apache.ws.resource.properties.ResourcePropertySet m_propSet;

    /**
     * A list of termination listeners to be notified when the resource is terminated.
     */
    private java.util.List m_terminationListeners = new java.util.ArrayList();

    /**
     * DOCUMENT_ME
     *
     * @param id DOCUMENT_ME
     */
    public void setID( Object id )
    {
        if ( m_id != null )
        {
            throw new IllegalStateException( "This resource's ID has already been set." );
        }

        try
        {
            m_id = (String) id;
        }
        catch ( ClassCastException cce )
        {
            throw new IllegalArgumentException( "Specified ID is not a String." );
        }
    }

    /**
     * DOCUMENT_ME
     *
     * @param listener DOCUMENT_ME
     */
    public void addTerminationListener( org.apache.ws.resource.lifetime.ResourceTerminationListener listener )
    {
        m_terminationListeners.add( listener );
    }

    /**
     * DOCUMENT_ME
     *
     * @return DOCUMENT_ME
     */
    public Object getID()
    {
        return m_id;
    }

    public void destroy()
    {
        org.apache.ws.resource.lifetime.ResourceTerminationEvent rte = new org.apache.ws.resource.lifetime.impl.ResourceTerminationEventImpl(
                getID(), "Resource Destroyed" );
        for ( int i = 0; i < m_terminationListeners.size(); i++ )
        {
            org.apache.ws.resource.lifetime.ResourceTerminationListener resourceTerminationEventListener = (org.apache.ws.resource.lifetime.ResourceTerminationListener) m_terminationListeners.get(
                    i );
            resourceTerminationEventListener.terminationOccurred( rte );
        }
        return;
    }

    public void init()
    {
        org.apache.ws.resource.example.filesystem.FileSystemPropertiesDocument propsDoc = org.apache.ws.resource.example.filesystem.FileSystemPropertiesDocument.Factory.newInstance();
        m_propSet = new org.apache.ws.resource.properties.impl.XmlBeansResourcePropertySet( propsDoc );

        // initialize wsrl:CurrentTime property
        org.apache.ws.resource.properties.ResourceProperty prop = m_propSet.get(
                org.apache.ws.resource.lifetime.v2004_06.porttype.ScheduledResourceTerminationPortType.PROP_QNAME_CURRENT_TIME );
        org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceLifetime12Draft01.CurrentTimeDocument currTime = org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceLifetime12Draft01.CurrentTimeDocument.Factory.newInstance();
        currTime.setCurrentTime( java.util.Calendar.getInstance() );
        prop.add( currTime );
        prop.setCallback( new org.apache.ws.resource.lifetime.callback.CurrentTimeCallback() );

        // initialize wsrl:TerminationTime property
        prop =
                m_propSet.get(
                        org.apache.ws.resource.lifetime.v2004_06.porttype.ScheduledResourceTerminationPortType.PROP_QNAME_TERMINATION_TIME );
        org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceLifetime12Draft01.TerminationTimeDocument termTime = org.oasisOpen.docs.wsrf.x2004.x06.wsrfWSResourceLifetime12Draft01.TerminationTimeDocument.Factory.newInstance();
        termTime.setNilTerminationTime();
        prop.add( termTime );
    }

    /**
     * Returns the EndpointReference associated with this Resource.
     *
     * @return The Resource's EndpointReference or null if the EndpointReference has not been set.
     *         <p/>
     *         Note: It is the responsibility of the Resource creator to set the EndpointReference (i.e. ResourceHome
     *         impl)
     */
    public EndpointReference getEndpointReference()
    {
        return m_endpointReference;
    }

    /**
     * Sets the EndpointReference associated with this Resource.
     *
     * @param epr The Resource's EndpointReference.
     *            <p/>
     *            Note: It is the responsibility of the Resource creator to set the EndpointReference (i.e. ResourceHome
     *            impl)
     */
    public void setEndpointReference( EndpointReference epr )
    {
        m_endpointReference = epr;
    }

    /**
     * DOCUMENT_ME
     *
     * @param time DOCUMENT_ME
     */
    public void setTerminationTime( java.util.Calendar time )
    {
        org.apache.ws.resource.properties.XmlBeansResourcePropertyUtils.setDateTimePropertyValue(
                (org.apache.ws.resource.properties.impl.XmlBeansResourceProperty) getResourcePropertySet().get(
                        org.apache.ws.resource.lifetime.v2004_06.porttype.ScheduledResourceTerminationPortType.PROP_QNAME_TERMINATION_TIME ),
                time );
    }

    /**
     * Returns the current time from the prop set.
     *
     * @return java.util.Calendar
     */
    public java.util.Calendar getCurrentTime()
    {
        return org.apache.ws.resource.properties.XmlBeansResourcePropertyUtils.getDateTimePropertyValue(
                (org.apache.ws.resource.properties.impl.XmlBeansResourceProperty) m_propSet.get(
                        org.apache.ws.resource.lifetime.v2004_06.porttype.ScheduledResourceTerminationPortType.PROP_QNAME_CURRENT_TIME ) );
    }

    /**
     * DOCUMENT_ME
     *
     * @return DOCUMENT_ME
     */
    public java.util.Calendar getTerminationTime()
    {
        return org.apache.ws.resource.properties.XmlBeansResourcePropertyUtils.getDateTimePropertyValue(
                (org.apache.ws.resource.properties.impl.XmlBeansResourceProperty) m_propSet.get(
                        org.apache.ws.resource.lifetime.v2004_06.porttype.ScheduledResourceTerminationPortType.PROP_QNAME_TERMINATION_TIME ) );
    }

    /**
     * @see org.apache.ws.resource.PropertiesResource#setResourcePropertySet(org.apache.ws.resource.properties.ResourcePropertySet)
     */
    public void setResourcePropertySet( org.apache.ws.resource.properties.ResourcePropertySet propSet )
    {
        m_propSet = propSet;
    }

    /**
     * @see org.apache.ws.resource.PropertiesResource#getResourcePropertySet()
     */
    public org.apache.ws.resource.properties.ResourcePropertySet getResourcePropertySet()
    {
        return m_propSet;
    }

    /**
     * @see org.apache.ws.resource.Resource#getNamespaceSet()
     */
    public NamespaceVersionHolder getNamespaceSet()
    {
        return SPEC_NAMESPACE_SET;
    }

}
